// Setup data
let $searchable_fields = ['lem','BnFfr4967', 'BnFfr5299', 'BnFfr23145', 'BnFfr49967', 'Cha514', 'BnFfr23146', 'BnFfr17274',
'Vat966', 'Aix419', 'BnFfr1724', 'Aix966'];
let $showable_fields = ['book', 'chapter', 'n', 'lem','BnFfr4967', 'BnFfr5299', 'BnFfr23145', 'BnFfr49967', 'Cha514', 'BnFfr23146', 'BnFfr17274',
'Vat966', 'Aix419', 'BnFfr1724', 'Aix966'];
// Setup MiniSearch
let miniSearch = new MiniSearch({
fields: $searchable_fields, // fields to index for full-text search
storeFields: $showable_fields // fields to return with search results
})
let $data_json = 'static/json/auto_index.json';

const renderSearchResults = (results) => {
    //JSON.stringify(results);
    //results = results.filter((result) => result.book == 1)//filter book 1
    //results.sort((a,b) => a.n - b.n); //sort by n (only)
    
    const books = new Set(results.map(a => a.book));
    
    let $result;
    $resultsList.innerHTML = "";
    for (let b of books){
        $resultsList.innerHTML += "<h4>Livre "+b+"</h4>\n";
        //filter by book
        results_by_book = results.filter((result) => result.book == b)
        //sort by n
        results_by_book.sort((a,b) => {
        return (a.n - b.n);
    });
    
    //}
    
    $resultsList.innerHTML += results_by_book.map(({ book, chapter, n, lem,BnFfr4967, BnFfr5299, BnFfr23145, BnFfr49967, Cha514, BnFfr23146, BnFfr17274, Vat966,
Aix419, BnFfr1724, Aix966 }) => {
    let $chap = `${chapter}`.substring(0, `${chapter}`.indexOf("_"));
    $result='<h5 xmlns="http://www.w3.org/1999/xhtml" class="mt-3">Vers <a href="';
    $result+=`/book${book}/${chapter}#${n}">${n}</a> (chapitre `
    $result+=$chap
    $result+=`)</h5><dl xmlns="http://www.w3.org/1999/xhtml">
    <dt>Lemme :</dt>
   <dd>${lem}</dd>`
    if (! (`${BnFfr4967}` === "undefined") ) {
      $result += `
   <dt>BnFfr4967 : </dt>
   <dd>${BnFfr4967}</dd>
    `}
    if (! (`${BnFfr5299}` === "undefined") ) {
      $result += `
   <dt>BnFfr5299 : </dt>
   <dd>${BnFfr5299}</dd>
    `}
    if (! (`${BnFfr23145}` === "undefined") ) {
      $result += `
   <dt>BnFfr23145 : </dt>
   <dd>${BnFfr23145}</dd>
    `}
    if (! (`${BnFfr49967}` === "undefined") ) {
      $result += `
   <dt>BnFfr49967 : </dt>
   <dd>${BnFfr49967}</dd>
    `}
    if (! (`${Cha514}` === "undefined") ) {
      $result += `
   <dt>Cha514 : </dt>
   <dd>${Cha514}</dd>
    `}
    if (! (`${BnFfr23146}` === "undefined") ) {
      $result += `
   <dt>BnFfr23146 : </dt>
   <dd>${BnFfr23146}</dd>
    `}
    if (! (`${BnFfr17274}` === "undefined") ) {
      $result += `
   <dt>BnFfr17274 : </dt>
   <dd>${BnFfr17274}</dd>
    `}
    if (! (`${Vat966}` === "undefined") ) {
      $result += `
   <dt>Vat966 : </dt>
   <dd>${Vat966}</dd>
    `}
    if (! (`${Aix419}` === "undefined") ) {
      $result += `
   <dt>Aix419 : </dt>
   <dd>${Aix419}</dd>
    `}
    if (! (`${BnFfr1724}` === "undefined") ) {
      $result += `
   <dt>BnFfr1724 : </dt>
   <dd>${BnFfr1724}</dd>
    `}
    if (! (`${Aix966}` === "undefined") ) {
      $result += `
   <dt>Aix966 : </dt>
   <dd>${Aix966}</dd>
    `}
    $result += `</dl>`
    
    return $result
}).join('\n')
}


        if (results.length > 0) {
            $app.classList.add('hasResults')
        } else {
            $app.classList.remove('hasResults')
        }
      }
      
      const getSuggestions = (query) => {
      return miniSearch.autoSuggest(query, { boost: { source_author: 3, fragment: 6} })
        .filter(({ suggestion, score }, _, [first]) => score > first.score / 4)
        .slice(0, 5)
      }
        