window.onload = function () {
  visuInit();
  exploreInit();
  imageHandler.init();
  pageInit();

  changePath();
}

async function getData() {
  const response = await fetch("../static/json/list_paints_zones.json");
  return response.json();
}

// Init tabs to show : in function of the chosen visualisation (image, diplo,
// linear) for left and right tab
function visuInit() {


  var chosenVisu = document.getElementById("visu").textContent;

  // Default values
  var leftVisu = "image-left";
  var rightVisu = "description-right";

  if (chosenVisu != "") {
    leftVisu = chosenVisu.split("_")[0];
    rightVisu = chosenVisu.split("_")[1];
  } else {
    document.getElementById("visu").textContent = leftVisu + "_" + rightVisu;
  }

  var left = document.getElementById(leftVisu);
  var right = document.getElementById(rightVisu);
  // boutons nav-tab
  // var tabLeft = document.getElementById(leftVisu + '-tab');
  // var tabRight = document.getElementById(rightVisu + '-tab');

  // var toActive = [tabLeft, tabRight, left, right];
  var toShow = [left, right];

  // for (var tab of toActive) {
  //   tab.classList.add('active');
  // }
  for (var tab of toShow) {
    tab.classList.add('show');
    tab.classList.add('active');
  }
}

// Scroll to a specific page and a specific verse if they are in url
function pageInit() {
  // if page nb in url : simulate a click on thumbnail
  var pageNb = document.getElementById("pageNb").innerText;
  if (pageNb != "") {
    let leftThumbnail = document.querySelector('#image-left-f' + pageNb);
    leftThumbnail.click();
  }
}

function activeTabs() {
  var tabs = document.getElementsByClassName("btn-tab");
  var leftTab = "";
  var rightTab = "";
  for (var i = 0; i < tabs.length; i++) {
    if (tabs[i].classList.contains("active")) {
      var id = tabs[i].id;
      if (id.split("-")[1] == "left") {
        leftTab = id.split("-")[0] + "-" + id.split("-")[1];
      } else if (id.split("-")[1] == "right") {
        rightTab = id.split("-")[0] + "-" + id.split("-")[1];
      }
    }
  }
  return [leftTab, rightTab];
}

const imageHandler = {
  viewer: Array(),
  options: {
    id: "fabricjsOverlay",
    selection: false, // NE MARCHE PAS
    scale: 1000,
    // scale: 1015,
    // to detail hovering zone
    perPixelTargetFind: true,
    targetFindTolerance: 0
  },
  overlay: Object(),
  polygonsAreas: [],
  init: function () {
    this.createPageDivs();
    imageHandler.viewer["left"] = new OpenSeadragon.Viewer({
      id: "openseadragon-left",
      showNavigator: false,
      showRotationControl: true,
      prefixUrl: '../static/img/libs/',
      zoomInButton: 'osd-zoom-in-left',
      zoomOutButton: 'osd-zoom-out-left',
      homeButton: 'osd-home-left',
      fullPageButton: 'osd-full-page-left',
      rotateLeftButton: 'osd-left-left',
      rotateRightButton: 'osd-right-left'
    });
    imageHandler.viewer["right"] = new OpenSeadragon.Viewer({
      id: 'openseadragon-right',
      showNavigator: false,
      showRotationControl: true,
      prefixUrl: '../static/img/libs/',
      zoomInButton: 'osd-zoom-in-right',
      zoomOutButton: 'osd-zoom-out-right',
      homeButton: 'osd-home-right',
      fullPageButton: 'osd-full-page-right',
      rotateLeftButton: 'osd-left-right',
      rotateRightButton: 'osd-right-right'
    });
    const thumbnails = document.querySelectorAll('.img-thumbnail');
    [].forEach.call(thumbnails, function (element) {
      element.addEventListener("click", imageHandler.change);
    });

    let url = thumbnails[0].dataset.img;

    let pageNb = document.getElementById("pageNb").innerText;
    if (pageNb != "") {
      url = document.querySelector('#image-left-f' + pageNb).dataset.img;
    }
    // initialisation de l'overlay pour y afficher les zonages
    this.overlay = this.viewer["left"].fabricjsOverlay(this.options);
    displayFigures(this.viewer["left"], url);

    imageHandler.display("left", thumbnails[0], false);
    imageHandler.display("right", thumbnails[0], false);

    window.onscroll = function () {
      let body = document.querySelector('body');
      if (window.scrollY >= 300) {
        body.classList.add("scrolled");
      } else {
        body.classList.remove("scrolled");
      }
    };

    let toggleBtns = document.querySelectorAll('.toggle-mark');
    [].forEach.call(toggleBtns, function (toggleBtn) {
      toggleBtn.addEventListener("click", imageHandler.toggleMark);
    });

    let descriptionsZones = document.querySelectorAll(".description-zone");
    for (let i = 0; i < descriptionsZones.length; i++) {
      descriptionsZones[i].addEventListener(
        "mousedown",
        function (event) {
          corresps = document.querySelectorAll(".corresp")
          for( let y = 0; y < corresps.length; y++){
            corresps[y].classList.remove("corresp");
          }
          let item = 1;

          // ne fonctionne pas encore
          for( let a = 0; a < event.target.parentElement.parentElement.classList.length; a++){
            zoneId = event.target.parentElement.parentElement.classList[a];
            for (let z = 0; z < imageHandler.polygonsAreas.length; z++) {
              const polyId = imageHandler.polygonsAreas[z].id;
              let polyNumber = z+1;
              if (zoneId == polyId){
                item = polyNumber;
                break;
              }            
            }
            console.log(imageHandler.overlay.fabricCanvas().item(item));
            imageHandler.overlay.fabricCanvas().item(item).set('fill', '#DEC9BF');
            imageHandler.overlay.fabricCanvas().item(item).set('opacity', '0.5');
            imageHandler.overlay.fabricCanvas().item(item).set('dirty', 'true')
            imageHandler.overlay.fabricCanvas().requestRenderAll();
            imageHandler.overlay.fabricCanvas().item(item).set('dirty', 'false')
            console.log(imageHandler.overlay.fabricCanvas().item(item));
            // imageHandler.overlay.fabricCanvas().item(item).click();
          }
          event.target.parentElement.parentElement.classList.add("corresp");

        },
        false,
      );
    }

  },
  toggleMark: function (evt) {
    let btn = evt.currentTarget;
    let pos = btn.dataset.pos;
    let type = btn.dataset.type;
    // console.log(document.querySelector('#nav-tabContent-' + pos));

    document.querySelector('#nav-tabContent-' + pos).classList.toggle('disabled-' + type);
  },
  change: function (evt) {
    let previous;
    let thumbnail = evt.currentTarget;
    let pos = thumbnail.dataset.pos;
    let url = thumbnail.dataset.img;

    if (previous = document.querySelector('#nav-tabContent-' + pos + ' .img-thumbnail.current')) {
      previous.classList.remove('current');
    }
    thumbnail.classList.add('current');

    displayFigures(imageHandler.viewer["left"], url);

    imageHandler.display(pos, thumbnail, true);

    changePath();

  },

  display: function (where, thumbnail, scroll) {
    let url = thumbnail.dataset.img;
    let position = thumbnail.id.substr(thumbnail.id.lastIndexOf("-") + 1);
    if (url) {
      imageHandler.viewer[where].open({
        type: 'image',
        url: url
      });
    }
    this.colorPageDiv(position, scroll);
  },
  changeImg: function (evt) {
    let previous;
    let target = evt.target;
    let div = target.closest('[data-img-id]');
    let id = div.getAttribute('data-img-id');

    if (previous = document.querySelector('.img-thumbnail.current')) {
      previous.classList.remove('current');
    }

    let leftThumbnail = document.querySelector('#image-left-' + id);
    let rightThumbnail = document.querySelector('#image-right-' + id);

    imageHandler.display("left", leftThumbnail, false);
    imageHandler.display("right", rightThumbnail, false);

    let url = leftThumbnail.dataset.img;
    displayFigures(imageHandler.viewer["left"], url);

    if (previous = document.querySelector('#nav-tabContent-left .img-thumbnail.current')) {
      previous.classList.remove('current');
    }
    if (previous = document.querySelector('#nav-tabContent-right .img-thumbnail.current')) {
      previous.classList.remove('current');
    }
    leftThumbnail.classList.add('current');
    rightThumbnail.classList.add('current');
    changePath();
  },
  removePageDivColor: function () {
    let pageTextDivs = document.querySelectorAll('.current-page-text');
    for (var pageTextDiv of pageTextDivs) {
      pageTextDiv.classList.remove('current-page-text');
    }
  },
  colorPageDiv: function (position, scroll) {
    this.removePageDivColor();
    let pageTextDivs = document.querySelectorAll(`div[data-img-id="${position}"]`);
    for (var pageTextDiv of pageTextDivs) {
      pageTextDiv.classList.add('current-page-text');
    }
    if (scroll) {
      let currentPageDiv = document.querySelector('.tab-pane.show div.current-page-text');
      if (currentPageDiv) {
        currentPageDiv.scrollIntoView(true);
      }
    }
  },
  createPageDivs: function () {
    const hrs = document.querySelectorAll('hr');
    for (var hr of hrs) {
      let next = hr.nextSibling;
      let div = document.createElement('div');
      hr.parentNode.insertBefore(div, next);
      div.classList.add('page-div');
      div.setAttribute('data-img-id', hr.getAttribute('data-img-id'));
      div.addEventListener("click", imageHandler.changeImg);
      while (next) {
        let node = next;
        next = next.nextSibling;
        div.appendChild(node);
        if (!next || next.nodeName == 'HR') break;
      }
    }
  }
}

// display described zones on images
const displayFigures = function (viewer, url) {

  let currentImage = url;

  // viewer.addHandler('open', function() {
  let viewport = viewer.viewport;

  // let overlay = viewer.svgOverlay();
  imageHandler.overlay.fabricCanvas().clear();
  console.log(currentImage);

  getData().then((data) => {

    let jsonMention = data[0];
    zoom = false;
    let i = 0;

    let polygonsPoints = Object();
    // let polygonsAreas = [];

    // dessine les zones décrites
    if (jsonMention.hasOwnProperty(currentImage)) {

      // get polygons points and their areas
      for (let figure in jsonMention[currentImage]) {
        i++;
        let points = jsonMention[currentImage][figure];

        newpoints = []
        for (let index = 0; index < points.length; index++) {
          newpoints.push([points[index]["x"], points[index]["y"]]);
        }
        polygonsPoints[figure] = points;
        imageHandler.polygonsAreas.push({ "id": figure, "area": calculateArea(newpoints) });
      }

      // sort polygons by area
      imageHandler.polygonsAreas.sort(function (a, b) {
        return a.area - b.area;
      });
      imageHandler.polygonsAreas.reverse();

      // draw polygons zones in descending orders of areas to avoid overlaps
      for (let i = 0; i < imageHandler.polygonsAreas.length; i++) {

        let polyId = imageHandler.polygonsAreas[i].id;
        let points = polygonsPoints[polyId];

        // create poly zone
        let poly = new fabric.Polygon(points, {
          id: polyId,
          // stroke: 'red',
          stroke: '#B22222',
          strokeWidth: 3,
          fill: 'transparent',
          // make it impossible to drag or resize zone
          lockRotation: true,
          lockScalingX: true,
          lockScalingY: true,
          lockMovementX: true,
          lockMovementY: true,
          // to detail hovering zone
          perPixelTargetFind: true,
          // remove selection lines
          // hasBorders: false,
          hasControls: false,
          dirty: false,
          hoverCursor: 'pointer'
        });

        // remove draggability indicator
        poly.setControlsVisibility({ mtr: false })

        // add poly zone to canva
        imageHandler.overlay.fabricCanvas().add(poly);
      }
    }

    // highlight clicked zone description
    imageHandler.overlay.fabricCanvas().on('mouse:up', function (e) {

      let previousRefs = document.querySelectorAll(".corresp");
      for (var previousRef of previousRefs) {
        previousRef.classList.remove('corresp');
      }
      if (e.target) {
        console.log(e.target["id"])
        let refs = document.querySelectorAll("." + e.target["id"]);
        for (var ref of refs) {
          if (!ref.classList.contains("corresp")) {
            ref.classList.add('corresp');
            ref.scrollIntoView({ block: "center" });
          }
        }
      }
    });

    // color overflown zones
    imageHandler.overlay.fabricCanvas().on('mouse:over', function (e) {
      if (e.target) {
        // e.target.set('fill', 'pink')
        e.target.set('fill', '#DEC9BF')
        e.target.set('opacity', '0.5')
        // redraw only dirty zones
        e.target.set('dirty', 'true')
        imageHandler.overlay.fabricCanvas().requestRenderAll();
        e.target.set('dirty', 'false')

        // display zones notes
        document.querySelector("#zones-infos").innerText = document.querySelector("#" + e.target["id"] + "-note").innerText;
        document.querySelector("#zones-infos").style.display = "block";
      }
    });

    // uncolor preceding overflown zones
    imageHandler.overlay.fabricCanvas().on('mouse:out', function (e) {
      if (e.target) {
        e.target.set('fill', 'transparent')
        // redraw only dirty zones
        e.target.set('dirty', 'true')
        imageHandler.overlay.fabricCanvas().requestRenderAll();
        e.target.set('dirty', 'false')

        // display zones notes
        document.querySelector("#zones-infos").innerText = "";
        document.querySelector("#zones-infos").style.display = "none";
      }
    });
  });
}




// get current path, chapter, page and visu informations to change url
function changePath() {
  var ancientPath = window.location.href;
  var newPath = window.location.pathname.split("/").slice(0, 2).join("/");
  // var visuLeft = document.getElementById("nav-tab-left").getElementsByClassName("nav-link active")[0].getAttribute("aria-controls");
  // var visuRigth = document.getElementById("nav-tab-right").getElementsByClassName("nav-link active")[0].getAttribute("aria-controls");
  // var visu = visuLeft + "_" + visuRigth;
  visu = "image-left_description-right";
  document.getElementById("visu").textContent = visu;
  var page = document.getElementsByClassName("current-page-text")[0].getAttribute("data-img-id").replace("f", "p");
  // var chapter = document.getElementById("chapName").textContent;

  // newPath += "/" + page + "/" + visu;
  newPath += "/" + page;

  let stateObj = {
    id: "url"
  };
  window.history.replaceState(stateObj, "", newPath);
}

function calculateArea(coords) {
  let area = 0;
  for (let i = 0; i < coords.length; i++) {
    const [x1, y1] = coords[i];
    const [x2, y2] = coords[(i + 1) % coords.length];
    area += x1 * y2 - x2 * y1
  }
  return Math.abs(area) / 2;
}
